<?php
defined('APP') or die('Hacking attemp!');
class Controller_Admincp extends Core_Controller{
	private $UserLogin;
	function __construct(){
		parent::__construct();
		if(isset($_SESSION['adid'])){
			parent::loadModel('user');
			$this->user->setId($_SESSION['adid']);
			$this->UserLogin = $this->user->getUser();
			$this->view->user = $this->UserLogin;
			}
		$this->view->settings = $this->settings;
		}
	public function loginAction(){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['amsmsignin'])){
			if(!isset($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter admin email';
			elseif(!isset($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter password';
			else{
				parent::loadModel('user');
				$this->user->setEmail(addslashes($_POST['email']));
				$this->user->setPassword(addslashes($_POST['password']));
				$result = $this->user->AdminLoginCP();
				if($result==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($result==-2)
					$this->view->error = 'Email or password incorrect !';
				else{
					$_SESSION['adid'] = $result;
					$_SESSION['adminem'] = trim($_POST['email']);
					header('Location: '.BASE_URL.'?admincp');
					return;
					}
				}
			}
		$this->view->render('admin/signin');
    	}
	public function signoutAction(){
		unset($_SESSION['adid']);
		unset($_SESSION['adminem']);
		header('Location: '.BASE_URL.'?admincp&login');
		return;
    	}
	public function admforgotAction(){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['amsmsignin'])){
			if(!isset($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter admin email';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Your email invalid';
			elseif(!isset($_POST['code']) || trim($_POST['code'])=='')
				$this->view->err_c = 'Please enter security code';
			elseif(trim($_POST['code']) != $_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				parent::loadModel('user');
				$this->user->setEmail(addslashes($_POST['email']));
				$result = $this->user->AdminForgotPass($this->random_string(32));
				if($result==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($result==-2)
					$this->view->error = 'Email not exits !';
				elseif($result==-3)
					$this->view->error = 'Can not process request';
				else{
					$mess = 'Dear, '.$_POST['email'].' !!<br><br>Please <a href="'.BASE_URL.'?admincp&recoverpass&str='.$result.'">click here</a> to reset your password on '.$this->settings->SiteName.'<br><br>
Best regards !';
					$this->view->succ = 'An email has sent to you. Please check email for recovery password';
					@mail(trim($_POST['email']), '=?UTF-8?B?'.base64_encode('Recovery admin password '.$this->settings->SiteName).'?=', $mess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
					}
				}
			}
		$this->view->render('admin/admforgot');
    	}
	public function recoverpassAction(array $param){
		parent::loadModel('user');
		if(!array_key_exists('str',$param) || empty($param['str']) || trim($param['str'])=='')
			$this->view->invalid = 'Your input data invalid';
		if(!$this->user->chkKey($param['str']))
			$this->view->invalid = 'Your input data invalid';
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['amsmreco'])){
			if(!isset($_POST['newpass']) || trim($_POST['newpass'])=='')
				$this->view->err_n = 'Please enter new password';
			elseif(trim($_POST['newpass'])!=trim($_POST['repass']))
				$this->view->err_r = 'Please verify new password';
			elseif(!isset($_POST['code']) || trim($_POST['code'])=='')
				$this->view->err_c = 'Please enter security code';
			elseif(trim($_POST['code']) != $_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				$this->user->setPassword(addslashes($_POST['newpass']));
				$this->user->setStrRandom($this->random_string(8));
				$rs = $this->user->AdminResetPassword($this->random_string(32),$param['str']);
				if($rs==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($rs==-2)
					$this->view->error = 'Your input data invalid';
				elseif($rs==-3)
					$this->view->error = 'Can not update your password';
				else $this->view->succ = 'Your password changed successfull. <a href="?admincp&login"><i>Sign-in here</i></a>';
				}
			}
		$this->view->render('admin/recoverpass');
    	}
    public function indexAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		$this->view->render('admin/home');
    	}
	public function menuAction(){
		$this->view->render('admin/menu');
    	}
	public function managepagesAction($param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		parent::loadModel('page');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			if($this->page->DeletePage($param['id'])){
				header('Location: '.BASE_URL.'?admincp&managepages');
				return;
				}
			else $this->view->error = 'Can not delete page';
			}
		$this->view->pages = $this->page->getPage();
		$this->view->render('admin/managepages');
    	}
	public function newpageAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managepages');
			return;
			}
		parent::loadModel('page');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewpage'])){
			if(!isset($_POST['namepage']) || trim($_POST['namepage'])=='')
				$this->view->err_n = 'Please enter the name page';
			elseif(!isset($_POST['contentPage']) || trim($_POST['contentPage'])=='')
				$this->view->err_b = 'Please enter body of page';
			else{
				$isac = ($_POST['isactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['namepage'])), addslashes(trim(htmlentities($_POST['contentPage']))), date('Y-m-d H:i:s'), $isac);
				if($this->page->AddPage($data)>0){
					header('Location: '.BASE_URL.'?admincp&managepages');
					return;
					}
				else $this->view->error = 'Can not add a page';
				}
			}
		$this->view->pages = $this->page->getPage();
		$this->view->render('admin/newpage');
    	}
	public function editpageAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if(!array_key_exists('pid',$param) && intval($param['pid'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managepages');
			return;
			}
		parent::loadModel('page');
		$this->page->setId($param['pid']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsavepage'])){
			if(!isset($_POST['namepage']) || trim($_POST['namepage'])=='')
				$this->view->err_n = 'Please enter the name page';
			elseif(!isset($_POST['contentPage']) || trim($_POST['contentPage'])=='')
				$this->view->err_b = 'Please enter body of page';
			else{
				$isac = ($_POST['isactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['namepage'])), addslashes(trim(htmlentities($_POST['contentPage']))), date('Y-m-d H:i:s'), $isac);
				if($this->page->UpdatePage($data)>0){
					header('Location: '.BASE_URL.'?admincp&managepages');
					return;
					}
				else $this->view->error = 'Can not update page';
				}
			}
		$this->view->pagedetail = $this->page->getPage();
		$this->view->render('admin/editpage');
    	}
	public function changepassAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smchange'])){
			if(!isset($_POST['curpass']) || trim($_POST['curpass'])=='')
				$this->view->err_c = 'Please enter current password';
			elseif(!isset($_POST['newpass']) || trim($_POST['newpass'])=='')
				$this->view->err_n = 'Please enter new password';
			elseif(trim($_POST['newpass'])!=trim($_POST['repass']))
				$this->view->err_r = 'Please verify new password';
			else{
				$this->user->setPassword(addslashes(trim(htmlentities($_POST['newpass']))));
				$this->user->setStrRandom($this->random_string(8));
				$resul = $this->user->adminChangePass(trim($_POST['curpass']));
				if($resul==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($resul==-2 || $resul==-3)
					$this->view->err_c = 'Current password incorrect !';
				elseif($resul==-4)
					$this->view->error = 'Can not change your password';
				else $this->view->succ = 'Your password changed successfull';
				}
			}
		$this->view->render('admin/changepass');
    	}
	public function backupdbAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		parent::loadModel('backup');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smbackup'])){
			if( 'SQL' == $_REQUEST['output_format'] ){
				$print_form=0;
				$filname = $_REQUEST['SeltTable']."_".date('YmdHis').'.sql';
				header('Content-type: text/plain');
				header("Content-Disposition: attachment; filename=$filname");
			echo "/*mysqldump.php */\n";
			   $this->backup->_mysqldump_table_data($_REQUEST['SeltTable']);
				}
			exit();
			}
		$this->view->tables = $this->backup->ShowTables();
		$this->view->render('admin/backupdb');
    	}
	public function manageusersAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&manageusers&'.http_build_query($_POST));
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->user->setId($param['id']);
			$rsl = $this->user->removeUser();
			if($rsl > 0){
				header('Location: '.BASE_URL.'?admincp&manageusers');
				return;
				}
			elseif($rsl==-3) $this->view->error = 'An error occurred, please try again';
			elseif($rsl==-2) $this->view->error = 'User deleted, but can not delete Book time off and history book.';
			elseif($rsl==-1) $this->view->error = 'User deleted, Book time off deleted but can not delete history book.';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, 'CONCAT(FullName,\' \',Email) like \'%'.trim(urldecode($param['name'])).'%\'');
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='1'){
				if(trim(urldecode($param['byear']))!='' && intval($param['byear'])>0 && checkdate(intval($param['bmonth']), intval($param['bday']), intval($param['byear'])))
					array_push($arr_temp, 'Birthday >= \''.date('Y-m-d', strtotime($param['byear'].'-'.$param['bmonth'].'-'.$param['bday'])).'\'');
				}
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='2'){
				if(trim(urldecode($param['byear']))!='' && intval($param['byear'])>0 && checkdate(intval($param['bmonth']), intval($param['bday']), intval($param['byear'])))
					array_push($arr_temp, 'Birthday <= \''.date('Y-m-d', strtotime($param['byear'].'-'.$param['bmonth'].'-'.$param['bday'])).'\'');
				}
			if($param['gender']>0)
				array_push($arr_temp, 'GenderId = '.$param['gender']);
			if(trim(urldecode($param['opadd']))!='' && $param['opadd']=='1'){
				if(trim(urldecode($param['ayear']))!='' && intval($param['ayear'])>0 && checkdate(intval($param['amonth']), intval($param['aday']), intval($param['ayear'])))
					array_push($arr_temp, 'DATE_FORMAT(AddedDate,\'%Y-%m-%d\') >= \''.date('Y-m-d', strtotime($param['ayear'].'-'.$param['amonth'].'-'.$param['aday'])).'\'');
				}
			if(trim(urldecode($param['opadd']))!='' && $param['opadd']=='2'){
				if(trim(urldecode($param['ayear']))!='' && intval($param['ayear'])>0 && checkdate(intval($param['amonth']), intval($param['aday']), intval($param['ayear'])))
					array_push($arr_temp, 'DATE_FORMAT(AddedDate,\'%Y-%m-%d\') <= \''.date('Y-m-d', strtotime($param['ayear'].'-'.$param['amonth'].'-'.$param['aday'])).'\'');
				}
			if(trim(urldecode($param['opst']))!='' && $param['opst']=='1'){
				if(trim(urldecode($param['syear']))!='' && intval($param['syear'])>0 && checkdate(intval($param['smonth']), intval($param['sday']), intval($param['syear'])))
					array_push($arr_temp, 'DATE_FORMAT(StartDate,\'%Y-%m-%d\') >= \''.date('Y-m-d', strtotime($param['syear'].'-'.$param['smonth'].'-'.$param['sday'])).'\'');
				}
			if(trim(urldecode($param['opst']))!='' && $param['opst']=='2'){
				if(trim(urldecode($param['syear']))!='' && intval($param['syear'])>0 && checkdate(intval($param['smonth']), intval($param['sday']), intval($param['syear'])))
					array_push($arr_temp, 'DATE_FORMAT(StartDate,\'%Y-%m-%d\') <= \''.date('Y-m-d', strtotime($param['syear'].'-'.$param['smonth'].'-'.$param['sday'])).'\'');
				}
			if(trim(urldecode($param['opend']))!='' && $param['opend']=='1'){
				if(trim(urldecode($param['eyear']))!='' && intval($param['eyear'])>0 && checkdate(intval($param['emonth']), intval($param['eday']), intval($param['eyear'])))
					array_push($arr_temp, 'DATE_FORMAT(EndDate,\'%Y-%m-%d\') >= \''.date('Y-m-d', strtotime($param['eyear'].'-'.$param['emonth'].'-'.$param['eday'])).'\'');
				}
			if(trim(urldecode($param['opend']))!='' && $param['opend']=='2'){
				if(trim(urldecode($param['eyear']))!='' && intval($param['eyear'])>0 && checkdate(intval($param['emonth']), intval($param['eday']), intval($param['eyear'])))
					array_push($arr_temp, 'DATE_FORMAT(EndDate,\'%Y-%m-%d\') <= \''.date('Y-m-d', strtotime($param['eyear'].'-'.$param['emonth'].'-'.$param['eday'])).'\'');
				}
			if($param['supvisor']>0)
				array_push($arr_temp, 'Supervisor = '.$param['supvisor']);
			if($param['emptype']>0)
				array_push($arr_temp, 'EmployeeType = '.$param['emptype']);
			if($param['group']>0)
				array_push($arr_temp, 'GroupId = '.$param['group']);
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->user->getAllUsers($arr_temp, ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&manageusers'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->users = $this->user->getAllUsers($arr_temp, $limit);
		parent::loadModel('gender');
		$this->view->genders = $this->gender->getObjGender();
		parent::loadModel('emptype');
		$this->view->types = $this->emptype->getObjType();
		$this->user->setGroupId(2);
		$this->view->visor = $this->user->getAllSupervisors();
		parent::loadModel('group');
		$this->view->groups = $this->group->getObjGroup();
		$this->view->render('admin/manageusers');
    	}
	public function newuserAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&manageusers');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewuser'])){
			if(!isset($_POST['fullname']) || trim($_POST['fullname'])=='')
				$this->view->err_n = 'Please enter fullname';
			elseif(!empty($_POST['btxtyear']) && !checkdate((int)$_POST['bmonth'], (int)$_POST['bday'], (int)$_POST['btxtyear']))
				$this->view->err_b = 'Birthday invalid';
			elseif(!empty($_POST['syear']) && !checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear']))
				$this->view->err_s = 'Start date invalid';
			elseif(!empty($_POST['eyear']) && !checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear']))
				$this->view->err_e = 'End date invalid';
			elseif(!isset($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_m = 'Please enter email address';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_m = 'This email invalid';
			elseif($this->user->chkEmailExist(trim($_POST['email'])))
				$this->view->err_m = 'This already in use';
			elseif(!isset($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter password';
			else{
				$strandom = $this->random_string(8);
				$bday = !checkdate((int)$_POST['bmonth'], (int)$_POST['bday'], (int)$_POST['btxtyear'])?'NULL':'\''.$_POST['btxtyear'].'-'.$_POST['bmonth'].'-'.$_POST['bday'].'\'';
				$sday = !checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear'])?'NULL':'\''.$_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'].'\'';
				$eday = !checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear'])?'NULL':'\''.$_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday'].'\'';
				$data = array(addslashes(trim($_POST['fullname'])), addslashes(trim($_POST['email'])), md5($strandom.addslashes(trim($_POST['password']))), $bday, $sday, $eday, intval($_POST['supvisor']), $_POST['emptype'], $_POST['group'], $_POST['timezone'], $_POST['workweek'], $_POST['calendar'], $_POST['sched'], $_POST['bookdel'], $_POST['bookapp'], $_POST['bookrej'], $_POST['bookmod'], $_POST['gender'], $_POST['bookadd']);
				$this->user->setStrRandom($strandom);
				$this->user->setStrActive($this->random_string(32));
				if($this->user->AddUser($data)>0){
					header('Location: '.BASE_URL.'?admincp&manageusers');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		parent::loadModel('gender');
		$this->view->genders = $this->gender->getObjGender();
		parent::loadModel('emptype');
		$this->view->types = $this->emptype->getObjType();
		$this->user->setGroupId(2);
		$this->view->visor = $this->user->getAllSupervisors();
		parent::loadModel('timezone');
		$this->view->zones = $this->timezone->getTimezone();
		parent::loadModel('workweek');
		$this->view->weeks = $this->workweek->getObjWorkWeek();
		parent::loadModel('calendar');
		$this->view->calen = $this->calendar->getCalendars();
		parent::loadModel('schedule');
		$this->view->sched = $this->schedule->getSchedule();
		parent::loadModel('group');
		$this->view->groups = $this->group->getObjGroup();
		$this->view->render('admin/newuser');
		}
	public function edituserAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&manageusers');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsaveuser'])){
			if(!isset($_POST['fullname']) || trim($_POST['fullname'])=='')
				$this->view->err_n = 'Please enter fullname';
			elseif(!empty($_POST['btxtyear']) && !checkdate((int)$_POST['bmonth'], (int)$_POST['bday'], (int)$_POST['btxtyear']))
				$this->view->err_b = 'Birthday invalid';
			elseif(!empty($_POST['syear']) && !checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear']))
				$this->view->err_s = 'Start date invalid';
			elseif(!empty($_POST['eyear']) && !checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear']))
				$this->view->err_e = 'End date invalid';
			elseif(strtolower($_POST['hddemail'])!=strtolower($_POST['email']) && (empty($_POST['email']) || trim($_POST['email'])==''))
				$this->view->err_m = 'Please enter email address';
			elseif(strtolower($_POST['hddemail'])!=strtolower($_POST['email']) && !$this->valid_email(trim($_POST['email'])))
				$this->view->err_m = 'This email invalid';
			elseif(strtolower($_POST['hddemail'])!=strtolower($_POST['email']) && $this->user->chkEmailExist(trim($_POST['email'])))
				$this->view->err_m = 'This already in use';
			elseif($_POST['hddpass']==1 && (!isset($_POST['password']) || trim($_POST['password'])==''))
				$this->view->err_p = 'Please enter password';
			else{
				$strandom = $this->random_string(8);
				$bday = !checkdate((int)$_POST['bmonth'], (int)$_POST['bday'], (int)$_POST['btxtyear'])?'NULL':'\''.$_POST['btxtyear'].'-'.$_POST['bmonth'].'-'.$_POST['bday'].'\'';
				$sday = !checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear'])?'NULL':'\''.$_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'].'\'';
				$eday = !checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear'])?'NULL':'\''.$_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday'].'\'';
				$data = array(addslashes(trim($_POST['fullname'])), addslashes(trim($_POST['email'])), md5($strandom.addslashes(trim($_POST['password']))), $bday, $sday, $eday, intval($_POST['supvisor']), $_POST['emptype'], $_POST['group'], $_POST['timezone'], $_POST['workweek'], $_POST['calendar'], $_POST['sched'], $_POST['bookdel'], $_POST['bookapp'], $_POST['bookrej'], $_POST['bookmod'], $_POST['gender'], $_POST['bookadd'], intval($_POST['hddpass']));
				$this->user->setStrRandom($strandom);
				$this->user->setStrActive($this->random_string(32));
				$this->user->setId($param['id']);
				if($this->user->UpdateUser($data)>0){
					header('Location: '.BASE_URL.'?admincp&manageusers');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		parent::loadModel('gender');
		$this->view->genders = $this->gender->getObjGender();
		parent::loadModel('emptype');
		$this->view->types = $this->emptype->getObjType();
		$this->user->setGroupId(2);
		$this->view->visor = $this->user->getAllSupervisors();
		parent::loadModel('timezone');
		$this->view->zones = $this->timezone->getTimezone();
		parent::loadModel('workweek');
		$this->view->weeks = $this->workweek->getObjWorkWeek();
		parent::loadModel('calendar');
		$this->view->calen = $this->calendar->getCalendars();
		parent::loadModel('schedule');
		$this->view->sched = $this->schedule->getSchedule();
		parent::loadModel('group');
		$this->view->groups = $this->group->getObjGroup();
		$this->user->setId($param['id']);
		$this->view->user = $this->user->getUser();
		$this->view->render('admin/edituser');
		}
	public function managebookingAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&managebooking&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('booktimeoff');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->booktimeoff->setId($param['id']);
			$rsl = $this->booktimeoff->AdminRemoveBooking();
			if($rsl > 0){
				header('Location: '.BASE_URL.'?admincp&managebooking');
				return;
				}
			elseif($rsl==-2) $this->view->error = 'An error occurred, please try again';
			elseif($rsl==-1) $this->view->error = 'Book time off deleted but can not delete history book.';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, 'CONCAT(u.FullName,\' \',u.Email) like \'%'.trim(urldecode($param['name'])).'%\'');
			if(checkdate(intval($param['smonth']), intval($param['sday']), intval($param['syear'])) && checkdate(intval($param['emonth']), intval($param['eday']), intval($param['eyear'])))
				array_push($arr_temp, 'bto.StartDate >= \''.date('Y-m-d', strtotime($param['syear'].'-'.$param['smonth'].'-'.$param['sday'])).'\' and bto.EndDate <= \''.date('Y-m-d', strtotime($param['eyear'].'-'.$param['emonth'].'-'.$param['eday'])).'\'');
			elseif(trim(urldecode($param['syear']))!='' && intval($param['syear'])>0 && checkdate(intval($param['smonth']), intval($param['sday']), intval($param['syear'])))
					array_push($arr_temp, 'bto.StartDate = \''.date('Y-m-d', strtotime($param['syear'].'-'.$param['smonth'].'-'.$param['sday'])).'\'');
			elseif(trim(urldecode($param['eyear']))!='' && intval($param['eyear'])>0 && checkdate(intval($param['emonth']), intval($param['eday']), intval($param['eyear'])))
					array_push($arr_temp, 'bto.EndDate = \''.date('Y-m-d', strtotime($param['eyear'].'-'.$param['emonth'].'-'.$param['eday'])).'\'');
			if($param['vstatus']>0)
				array_push($arr_temp, 'bto.Status = '.$param['vstatus']);
			if($param['vtype']>0)
				array_push($arr_temp, 'bto.Type = '.$param['vtype']);
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->booktimeoff->getAllBooks($arr_temp, ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managebooking'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->books = $this->booktimeoff->getAllBooks($arr_temp, $limit);
		parent::loadModel('timeofftype');
		$this->view->types = $this->timeofftype->getTimeoffType();
		parent::loadModel('status');
		$this->view->status = $this->status->getObjStatus();
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/managebooking');
    	}
	public function booktimeoffAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managebooking');
			return;
			}
		parent::loadModel('timeofftype');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewbook'])){
			if(!isset($_POST['user']) || intval($_POST['user'])==0)
				$this->view->err_n = 'Please select user';
			elseif(!checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear']))
				$this->view->err_s = 'Start date invalid';
			elseif(!checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear']))
				$this->view->err_e = 'End date invalid';
			elseif(strtotime($_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'])>strtotime($_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday']))
				$this->view->err_e = 'End date required greater than start date';
			else{
				parent::loadModel('booktimeoff');
				$this->user->setId($_POST['user']);
				$newuser = $this->user->getUser();
				parent::loadModel('schedule');
				$this->schedule->setId($newuser->getScheduleId());
				$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
				$this->booktimeoff->setCalendarId($newuser->getCalendarId());
				if(!$this->booktimeoff->chkAvalidDate($_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'], $_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday'])){
					$this->view->error = 'The date you selected in company holidays or member not working or invalid';
					}
				else{
					$sday = !checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear'])?'NULL':'\''.date('Y-m-d', strtotime($_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'])).'\'';
					$eday = !checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear'])?'NULL':'\''.date('Y-m-d', strtotime($_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday'])).'\'';
					$strrandom = $this->random_string(32);
					$strrandom[mt_rand(0,31)] = $_POST['user'];
					if($_POST['startdaytype']==1){
						$start_time = 'NULL';
						$start_hour = '0.00';
						}
					else{
						$start_time = '\''.addslashes($_POST['starttime']).'\'';
						$start_hour = (float)$_POST['starthour'];
						}
					if($_POST['enddaytype']==1){
						$end_time = 'NULL';
						$end_hour = '0.00';
						}
					else{
						$end_time = '\''.addslashes($_POST['endtime']).'\'';
						$end_hour = (float)$_POST['endhour'];
						}
					$data = array($_POST['user'], $_POST['vtype'], $sday, $eday, $_POST['startdaytype'], $start_hour, $start_time, $_POST['enddaytype'], $end_hour, $end_time, addslashes($_POST['addition']), 3, date('Y-m-d H:i:s'), sha1($strrandom), addslashes($_POST['txtaddition']));
					if($this->booktimeoff->AdminAddbook($data)>0){
						parent::loadModel('notifications');
						$this->user->setId($_POST['user']);
						$newuser = $this->user->getUser();
						$this->timeofftype->setId($_POST['vtype']);
						$timeoff = $this->timeofftype->getTimeoffType();
						$row = (object)array('StartDate'=>str_replace('\'', '', $sday), 'EndDate'=>str_replace('\'', '', $eday),'StartType'=>$_POST['startdaytype'],'EndType'=>$_POST['enddaytype'],'StartHours'=>(float)urldecode($_POST['starthour']),'EndHours'=>(float)urldecode($_POST['endhour']));
						$totalv = $this->booktimeoff->__caculationDays($row);
						if($newuser->getBookingNew()==1){
							$this->notifications->setId(6);
							$notify = $this->notifications->getObjNotify();
							$arr_frm = array('$FULLNAME','$TIMEOFFTYPE','$TIMEOFFSTART','$TIMEOFFEND','$TIMEOFFCOMMENT','$TIMEOFFDAYSREQUESTED','$URL');
							$arr_to = array($newuser->getFullName(),$timeoff->getTimeOffName(),str_replace('\'', '', $sday),str_replace('\'', '', $eday),$_POST['txtaddition'],$totalv,BASE_URL.'?member');
							$newmess = str_replace($arr_frm, $arr_to, html_entity_decode($notify->getBodyMail()));
							@mail(trim($newuser->getEmail()), '=?UTF-8?B?'.base64_encode($notify->getSubject().' - '.$this->settings->SiteName).'?=', $newmess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
							}
						$this->user->setSupervisor($newuser->getSupervisor());
						$email = $this->user->getEmailApprover();
						$this->notifications->setId(5);
						$notify = $this->notifications->getObjNotify();
						$strurl = ($newuser->getSupervisor()==1)?'?admincp&approvalbooking':'?timeoffbook&bookapprove&key='.sha1($strrandom);
						$arr_frm = array('$FULLNAME','$TIMEOFFTYPE','$TIMEOFFSTART','$TIMEOFFEND','$TIMEOFFCOMMENT','$TIMEOFFDAYSREQUESTED','$URL');
						$arr_to = array($newuser->getFullName(),$timeoff->getTimeOffName(),str_replace('\'', '', $sday),str_replace('\'', '', $eday),$_POST['txtaddition'],$totalv,BASE_URL.$strurl);
						$newmess = str_replace($arr_frm, $arr_to, html_entity_decode($notify->getBodyMail()));
						@mail(trim($email), '=?UTF-8?B?'.base64_encode(strtr($notify->getSubject(), '$FULLNAME', $newuser->getFullName()).' - '.$this->settings->SiteName).'?=', $newmess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
						header('Location: '.BASE_URL.'?admincp&managebooking');
						return;
						}
					else $this->view->error = 'An error occurred, please try again';
					}
				}
			}
		$this->timeofftype->setId(0);
		$this->view->types = $this->timeofftype->getTimeoffType();
		parent::loadModel('daytype');
		$this->view->typeday = $this->daytype->getDayType();
		$this->user->setId(0);
		$this->view->users = $this->user->getUser();
		$this->view->render('admin/booktimeoff');
		}
	public function loaduserremainAction(array $param){
		if(!array_key_exists('id', $param)){
			echo json_encode(array('validnow'=>0, 'requested'=>0, 'remained'=>0));
			return;
			}
		parent::loadModel('timeofftype');
		$this->timeofftype->setId($param['id']);
		$result = $this->timeofftype->getTimeoffType();
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setUserId($param['uid']);
		$this->booktimeoff->setType($param['id']);
		$this->booktimeoff->setCalendarId($this->settings->CalendarId);
		echo json_encode(array('validnow'=>$result->getAlowDays(), 'requested'=>$this->booktimeoff->getTotalBookTimeUserVationType(), 'remained'=>$result->getAlowDays()-$this->booktimeoff->getTotalBookTimeUserVationType()));
		}
	public function loadtypedayAction(array $param){
		if(checkdate((int)$param['sm'], (int)$param['sd'], (int)$param['sy']) && checkdate((int)$param['em'], (int)$param['ed'], (int)$param['ey'])){
			$start = $param['sy'].'-'.$param['sm'].'-'.$param['sd'];
			$end = $param['ey'].'-'.$param['em'].'-'.$param['ed'];
			if(strtotime($start)<strtotime($end))
				echo json_encode(array('status'=>1));
			else echo json_encode(array('status'=>-1));
			return;
			}
		else echo json_encode(array('status'=>-1));
		}
	public function updatebookAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managebooking');
			return;
			}
		parent::loadModel('timeofftype');
		parent::loadModel('booktimeoff');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smupdbook'])){
			if(!isset($_POST['user']) || trim($_POST['user'])=='')
				$this->view->err_n = 'Please select user';
			elseif(!checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear']))
				$this->view->err_s = 'Start date invalid';
			elseif(!checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear']))
				$this->view->err_e = 'End date invalid';
			elseif(strtotime($_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'])>strtotime($_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday']))
				$this->view->err_e = 'End date required greater than start date';
			else{
				$sday = !checkdate((int)$_POST['smonth'], (int)$_POST['sday'], (int)$_POST['syear'])?'NULL':'\''.date('Y-m-d', strtotime($_POST['syear'].'-'.$_POST['smonth'].'-'.$_POST['sday'])).'\'';
				$eday = !checkdate((int)$_POST['emonth'], (int)$_POST['eday'], (int)$_POST['eyear'])?'NULL':'\''.date('Y-m-d', strtotime($_POST['eyear'].'-'.$_POST['emonth'].'-'.$_POST['eday'])).'\'';
				$strrandom = $this->random_string(32);
				$strrandom[mt_rand(0,31)] = $_POST['user'];
				if($_POST['startdaytype']==1){
					$start_time = 'NULL';
					$start_hour = '0.00';
					}
				else{
					$start_time = '\''.addslashes($_POST['starttime']).'\'';
					$start_hour = (float)$_POST['starthour'];
					}
				if($_POST['enddaytype']==1){
					$end_time = 'NULL';
					$end_hour = '0.00';
					}
				else{
					$end_time = '\''.addslashes($_POST['endtime']).'\'';
					$end_hour = (float)$_POST['endhour'];
					}
				$data = array($_POST['user'], $_POST['vtype'], $sday, $eday, $_POST['startdaytype'], $start_hour, $start_time, $_POST['enddaytype'], $end_hour, $end_time, addslashes($_POST['addition']), 3, date('Y-m-d H:i:s'), sha1($strrandom), addslashes($_POST['txtaddition']));
				$this->booktimeoff->setId($param['id']);
				$this->booktimeoff->setUserId($_SESSION['adid']);
				if($this->booktimeoff->AdminUpdatebook($data)>0){
					parent::loadModel('notifications');
					$this->user->setId($_POST['user']);
					$newuser = $this->user->getUser();
					$this->timeofftype->setId($_POST['vtype']);
					$timeoff = $this->timeofftype->getTimeoffType();
					$row = (object)array('StartDate'=>str_replace('\'', '', $sday), 'EndDate'=>str_replace('\'', '', $eday),'StartType'=>$_POST['startdaytype'],'EndType'=>$_POST['enddaytype'],'StartHours'=>(float)urldecode($_POST['starthour']),'EndHours'=>(float)urldecode($_POST['endhour']));
					$totalv = $this->booktimeoff->__caculationDays($row);
					if($newuser->getBookingModified()==1){
						$this->notifications->setId(3);
						$notify = $this->notifications->getObjNotify();
						$arr_frm = array('$TIMEOFFTYPE','$TIMEOFFSTART','$TIMEOFFEND','$TIMEOFFCOMMENT','$COMMENT','$TIMEOFFDAYSREQUESTED','$URL');
						$arr_to = array($timeoff->getTimeOffName(),str_replace('\'', '', $sday),str_replace('\'', '', $eday),$_POST['txtaddition'],'Updated by admin',$totalv,BASE_URL.'?member');
						$newmess = str_replace($arr_frm, $arr_to, html_entity_decode($notify->getBodyMail()));
						@mail(trim($newuser->getEmail()), '=?UTF-8?B?'.base64_encode($notify->getSubject().' - '.$this->settings->SiteName).'?=', $newmess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
						}
					$this->user->setSupervisor($newuser->getSupervisor());
					$email = $this->user->getEmailApprover();
					$this->notifications->setId(5);
					$notify = $this->notifications->getObjNotify();
					$arr_frm = array('$FULLNAME','$TIMEOFFTYPE','$TIMEOFFSTART','$TIMEOFFEND','$TIMEOFFCOMMENT','$TIMEOFFDAYSREQUESTED','$URL');
					$arr_to = array($newuser->getFullName(),$timeoff->getTimeOffName(),str_replace('\'', '', $sday),str_replace('\'', '', $eday),$_POST['txtaddition'],$totalv,BASE_URL.'?timeoffbook&bookapprove&key='.sha1($strrandom));
					$newmess = str_replace($arr_frm, $arr_to, html_entity_decode($notify->getBodyMail()));
					@mail(trim($email), '=?UTF-8?B?'.base64_encode($notify->getSubject().' - '.$this->settings->SiteName).'?=', $newmess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
					header('Location: '.BASE_URL.'?admincp&managebooking');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->timeofftype->setId(0);
		$this->view->types = $this->timeofftype->getTimeoffType();
		parent::loadModel('daytype');
		$this->view->typeday = $this->daytype->getDayType();
		$this->user->setId(0);
		$this->view->users = $this->user->getUser();
		$this->booktimeoff->setId($param['id']);
		$this->view->book = $this->booktimeoff->AdmingetBookToEdit();
		$this->view->render('admin/updatebook');
		}
	public function calendarmanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&calendarmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('calendar');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->calendar->setId($param['id']);
			$rsl = $this->calendar->AdminRemove();
			if($rsl > 0){
				header('Location: '.BASE_URL.'?admincp&calendarmana');
				return;
				}
			elseif($rsl==-2) $this->view->error = 'An error occurred, please try again';
			elseif($rsl==-1) $this->view->error = 'Holiday calendar deleted but can not delete holidays detail.';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->calendar->AdminGetAllCalendar(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&calendarmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->cals = $this->calendar->AdminGetAllCalendar(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/calendarmana');
    	}
	public function addcalendarAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&calendarmana');
			return;
			}
		parent::loadModel('calendar');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter holidays calendar name';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->calendar->AdminAddCalendar($data)>0){
					header('Location: '.BASE_URL.'?admincp&calendarmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addcalendar');
    	}
	public function updatecalendarAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&calendarmana');
			return;
			}
		parent::loadModel('calendar');
		$this->calendar->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter holidays calendar name';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->calendar->AdminUpdCalendar($data)>0){
					header('Location: '.BASE_URL.'?admincp&calendarmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->cals = $this->calendar->getCalendarsEdit();
		$this->view->render('admin/updatecalendar');
    	}	
	public function emptypemanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&calendarmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('emptype');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->emptype->setId($param['id']);
			if($this->emptype->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&emptypemana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->emptype->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&calendarmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->emptype->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/emptypemana');
    	}
	public function addemptypeAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&emptypemana');
			return;
			}
		parent::loadModel('emptype');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter employee type';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->emptype->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&emptypemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addemptype');
    	}
	public function updateemptypeAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&emptypemana');
			return;
			}
		parent::loadModel('emptype');
		$this->emptype->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter employee type';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->emptype->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&emptypemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->emptype->getDataEdit();
		$this->view->render('admin/updateemptype');
    	}
	public function gendermanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&gendermana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('gender');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->gender->setId($param['id']);
			if($this->gender->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&gendermana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->gender->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&gendermana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->gender->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/gendermana');
    	}
	public function addgenderAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&gendermana');
			return;
			}
		parent::loadModel('gender');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter gender name';
			else{
				$isact = (isset($_POST['objactive']) && $_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->gender->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&gendermana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addgender');
    	}
	public function updategenderAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&gendermana');
			return;
			}
		parent::loadModel('gender');
		$this->gender->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter gender name';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->gender->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&gendermana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->gender->getDataEdit();
		$this->view->render('admin/updategender');
    	}
	public function groupmanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&groupmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('group');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->group->setId($param['id']);
			if($this->group->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&groupmana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->group->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&groupmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->group->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/groupmana');
    	}
	public function addgroupAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&groupmana');
			return;
			}
		parent::loadModel('group');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter group name';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->group->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&groupmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addgroup');
    	}
	public function updategroupAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&groupmana');
			return;
			}
		parent::loadModel('group');
		$this->group->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter group name';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->group->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&groupmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->group->getDataEdit();
		$this->view->render('admin/updategroup');
    	}
	public function statusmanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&statusmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('status');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->status->setId($param['id']);
			if($this->status->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&statusmana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->status->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&statusmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->status->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/statusmana');
    	}
	public function addstatusAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&statusmana');
			return;
			}
		parent::loadModel('status');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description status';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->status->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&statusmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addstatus');
    	}
	public function updatestatusAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&statusmana');
			return;
			}
		parent::loadModel('status');
		$this->status->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description status';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->status->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&statusmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->status->getDataEdit();
		$this->view->render('admin/updatestatus');
    	}
	public function workweekmanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&workweekmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('workweek');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->workweek->setId($param['id']);
			if($this->workweek->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&workweekmana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->workweek->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&workweekmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->workweek->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/workweekmana');
    	}
	public function addworkweekAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&statusmana');
			return;
			}
		parent::loadModel('workweek');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description work week';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->workweek->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&workweekmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addworkweek');
    	}
	public function updateworkweekAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&workweekmana');
			return;
			}
		parent::loadModel('workweek');
		$this->workweek->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description work week';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $isact);
				if($this->workweek->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&workweekmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->workweek->getDataEdit();
		$this->view->render('admin/updateworkweek');
    	}
	public function daytypemanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&daytypemana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('daytype');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->daytype->setId($param['id']);
			if($this->daytype->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&daytypemana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->daytype->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&daytypemana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->daytype->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/daytypemana');
    	}
	public function adddaytypeAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&daytypemana');
			return;
			}
		parent::loadModel('daytype');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description day type';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$ishour = ($_POST['ishour']=='on')?1:0;
				$istime = ($_POST['istime']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $ishour, $istime, $isact);
				if($this->daytype->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&daytypemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/adddaytype');
    	}
	public function updatedaytypeAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&daytypemana');
			return;
			}
		parent::loadModel('daytype');
		$this->daytype->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description work week';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$ishour = ($_POST['ishour']=='on')?1:0;
				$istime = ($_POST['istime']=='on')?1:0;
				$data = array(addslashes(trim($_POST['objname'])), $ishour, $istime, $isact);
				if($this->daytype->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&daytypemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->daytype->getDataEdit();
		$this->view->render('admin/updatedaytype');
    	}
	public function notifymanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&notifymana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('notifications');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->notifications->setId($param['id']);
			if($this->notifications->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&notifymana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->notifications->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&notifymana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->notifications->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/notifymana');
    	}
	public function addnotifyAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&notifymana');
			return;
			}
		parent::loadModel('notifications');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description email notify';
			elseif(!empty($_POST['replyto']) && !$this->valid_email(trim($_POST['replyto'])))
				$this->view->err_r = 'This is invalid';
			elseif(!isset($_POST['subject']) || trim($_POST['subject'])=='')
				$this->view->err_s = 'Please enter subject notify';
			elseif(!isset($_POST['bodymess']) || trim($_POST['bodymess'])=='')
				$this->view->err_m = 'Please enter message notify';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim(htmlentities($_POST['objname']))), addslashes(trim(htmlentities($_POST['replyto']))), addslashes(trim(htmlentities($_POST['subject']))), addslashes(trim(htmlentities($_POST['bodymess']))), $isact);
				if($this->notifications->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&notifymana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addnotify');
    	}
	public function updatenotifyAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&notifymana');
			return;
			}
		parent::loadModel('notifications');
		$this->notifications->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter description work week';
			elseif(!empty($_POST['replyto']) && !$this->valid_email(trim($_POST['replyto'])))
				$this->view->err_r = 'This is invalid';
			elseif(!isset($_POST['subject']) || trim($_POST['subject'])=='')
				$this->view->err_s = 'Please enter subject notify';
			elseif(!isset($_POST['bodymess']) || trim($_POST['bodymess'])=='')
				$this->view->err_m = 'Please enter message notify';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes(trim(htmlentities($_POST['objname']))), addslashes(trim(htmlentities($_POST['replyto']))), addslashes(trim(htmlentities($_POST['subject']))), addslashes(trim(htmlentities($_POST['bodymess']))), $isact);
				if($this->notifications->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&notifymana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->notifications->getDataEdit();
		$this->view->render('admin/updatenotify');
    	}
	public function holidaysmanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&holidaysmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('holiday');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->holiday->setId($param['id']);
			if($this->holiday->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&holidaysmana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, "HolidayName like '%".trim(urldecode($param['name']))."%'");
			if($param['slyear']>0)
				array_push($arr_temp, "YEAR(HolidayDate) = ".$param['slyear']);
			if($param['calendar']>0)
				array_push($arr_temp, "HolidayCalendar = ".$param['calendar']);
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->holiday->AdminGetAllData($arr_temp, ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&holidaysmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->holiday->AdminGetAllData($arr_temp, $limit);
		$this->view->total = $config['js_numrows_page'];
		parent::loadModel('calendar');
		$this->view->cals = $this->calendar->getCalendars();
		$this->view->minyear = $this->holiday->getYear('min');
		$this->view->maxyear = $this->holiday->getYear('max');
		$this->view->render('admin/holidaysmana');
    	}
	public function addholidayAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&holidaysmana');
			return;
			}
		parent::loadModel('holiday');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter holiday name';
			elseif(!checkdate((int)$_POST['bmonth'], (int)$_POST['bday'], (int)$_POST['byear']))
				$this->view->err_d = 'Holiday date invalid';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes($_POST['objname']), date('Y-m-d', strtotime($_POST['byear'].'-'.$_POST['bmonth'].'-'.$_POST['bday'])), $_POST['calendar'], $isact);
				if($this->holiday->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&holidaysmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		parent::loadModel('calendar');
		$this->view->cals = $this->calendar->getCalendars();
		$this->view->render('admin/addholiday');
    	}
	public function updateholidayAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&holidaysmana');
			return;
			}
		parent::loadModel('holiday');
		$this->holiday->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter holiday name';
			elseif(!checkdate((int)$_POST['bmonth'], (int)$_POST['bday'], (int)$_POST['byear']))
				$this->view->err_d = 'Holiday date invalid';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes($_POST['objname']), date('Y-m-d', strtotime($_POST['byear'].'-'.$_POST['bmonth'].'-'.$_POST['bday'])), $_POST['calendar'], $isact);
				if($this->holiday->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&holidaysmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->holiday->getDataEdit();
		parent::loadModel('calendar');
		$this->view->cals = $this->calendar->getCalendars();
		$this->view->render('admin/updateholiday');
    	}
	public function schedulemanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&schedulemana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('schedule');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->schedule->setId($param['id']);
			if($this->schedule->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&schedulemana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->schedule->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&schedulemana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->schedule->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/schedulemana');
    	}
	public function addscheduleAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&schedulemana');
			return;
			}
		parent::loadModel('schedule');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter schedule name';
			elseif(!isset($_POST['objdesc']) || trim($_POST['objdesc'])=='')
				$this->view->err_d = 'Please enter description schedule';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes($_POST['objname']), $_POST['objdesc'], (float)$_POST['sunhour'], (float)$_POST['monhour'], (float)$_POST['tuehour'], (float)$_POST['wedhour'], (float)$_POST['thuhour'], (float)$_POST['frihour'], (float)$_POST['sathour'], $isact);
				if($this->schedule->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&schedulemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addschedule');
    	}
	public function updatescheduleAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&schedulemana');
			return;
			}
		parent::loadModel('schedule');
		$this->schedule->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter schedule name';
			elseif(!isset($_POST['objdesc']) || trim($_POST['objdesc'])=='')
				$this->view->err_d = 'Please enter description schedule';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes($_POST['objname']), $_POST['objdesc'], (float)$_POST['sunhour'], (float)$_POST['monhour'], (float)$_POST['tuehour'], (float)$_POST['wedhour'], (float)$_POST['thuhour'], (float)$_POST['frihour'], (float)$_POST['sathour'], $isact);
				if($this->schedule->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&schedulemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->schedule->getDataEdit();
		$this->view->render('admin/updateschedule');
    	}
	public function timeoffmanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&timeoffmana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('timeofftype');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->timeofftype->setId($param['id']);
			if($this->timeofftype->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&timeoffmana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->timeofftype->AdminGetAllData(array(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&timeoffmana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->timeofftype->AdminGetAllData(array(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/timeoffmana');
    	}
	public function addstimeoffAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&timeoffmana');
			return;
			}
		parent::loadModel('timeofftype');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter time off type';
			elseif(!isset($_POST['objdesc']) || trim($_POST['objdesc'])=='')
				$this->view->err_d = 'Please enter description time off type';
			elseif(intval($_POST['alowday'])<=0 || !is_int((int)$_POST['alowday']))
				$this->view->err_a = 'Please enter num of alow days and it is an interger';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes($_POST['objname']), $_POST['objdesc'], (int)$_POST['alowday'], (int)$_POST['slincre'], $isact);
				if($this->timeofftype->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&timeoffmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		parent::loadModel('increment');
		$this->view->incre = $this->increment->getObjData();
		$this->view->render('admin/addstimeoff');
    	}
	public function updatetimeoffAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&timeoffmana');
			return;
			}
		parent::loadModel('timeofftype');
		$this->timeofftype->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter time off type';
			elseif(!isset($_POST['objdesc']) || trim($_POST['objdesc'])=='')
				$this->view->err_d = 'Please enter description time off type';
			elseif(intval($_POST['alowday'])<=0 || !is_int((int)$_POST['alowday']))
				$this->view->err_a = 'Please enter num of alow days and it is an interger';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array(addslashes($_POST['objname']), $_POST['objdesc'], (int)$_POST['alowday'], (int)$_POST['slincre'], $isact);
				if($this->timeofftype->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&timeoffmana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->timeofftype->getDataEdit();
		parent::loadModel('increment');
		$this->view->incre = $this->increment->getObjData();
		$this->view->render('admin/updatetimeoff');
    	}
	public function timezonemanaAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&timezonemana&'.http_build_query($_POST));
			return;
			}
		parent::loadModel('timezone');
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$this->timezone->setId($param['id']);
			if($this->timezone->AdminRemove()>0){
				header('Location: '.BASE_URL.'?admincp&timezonemana');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['namezone']))!='')
				array_push($arr_temp, "StrDisplay like '%".trim(urldecode($param['namezone']))."%'");
			if(trim(urldecode($param['display']))!='')
				array_push($arr_temp, "ValDisplay like '%".trim(urldecode($param['display']))."%'");
			if(intval($param['zval'])!=0)
				array_push($arr_temp, "ValZone = ".$param['zval']);
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->timezone->AdminGetAllData($arr_temp, ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&timezonemana'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->data = $this->timezone->AdminGetAllData($arr_temp, $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/timezonemana');
    	}
	public function addtimezoneAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&timezonemana');
			return;
			}
		parent::loadModel('timezone');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadnew'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter time zone name';
			elseif(!isset($_POST['objdesc']) || trim($_POST['objdesc'])=='')
				$this->view->err_d = 'Please enter short value';
			elseif(intval($_POST['alowday'])<=0 || !is_int((int)$_POST['alowday']))
				$this->view->err_a = 'Please enter num of value zone and it is an interger';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array((int)$_POST['alowday'], addslashes($_POST['objname']), addslashes($_POST['objdesc']), $isact);
				if($this->timezone->AdminAddData($data)>0){
					header('Location: '.BASE_URL.'?admincp&timezonemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('admin/addtimezone');
    	}
	public function updatetimezoneAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&timezonemana');
			return;
			}
		parent::loadModel('timezone');
		$this->timezone->setId($param['id']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(!isset($_POST['objname']) || trim($_POST['objname'])=='')
				$this->view->err_n = 'Please enter time zone name';
			elseif(!isset($_POST['objdesc']) || trim($_POST['objdesc'])=='')
				$this->view->err_d = 'Please enter short value';
			elseif(intval($_POST['alowday'])<=0 || !is_int((int)$_POST['alowday']))
				$this->view->err_a = 'Please enter num of value zone and it is an interger';
			else{
				$isact = ($_POST['objactive']=='on')?1:0;
				$data = array((int)$_POST['alowday'], addslashes($_POST['objname']), addslashes($_POST['objdesc']), $isact);
				if($this->timezone->AdminUpdData($data)>0){
					header('Location: '.BASE_URL.'?admincp&timezonemana');
					return;
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->data = $this->timezone->getDataEdit();
		$this->view->render('admin/updatetimezone');
    	}
	public function generatemailingAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&generatemailing&'.http_build_query($_POST));
			return;
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, 'CONCAT(FullName,\' \',Email) like \'%'.trim(urldecode($param['name'])).'%\'');
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='1'){
				if(trim(urldecode($param['byear']))!='' && intval($param['byear'])>0 && checkdate(intval($param['bmonth']), intval($param['bday']), intval($param['byear'])))
					array_push($arr_temp, 'Birthday >= \''.date('Y-m-d', strtotime($param['byear'].'-'.$param['bmonth'].'-'.$param['bday'])).'\'');
				}
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='2'){
				if(trim(urldecode($param['byear']))!='' && intval($param['byear'])>0 && checkdate(intval($param['bmonth']), intval($param['bday']), intval($param['byear'])))
					array_push($arr_temp, 'Birthday <= \''.date('Y-m-d', strtotime($param['byear'].'-'.$param['bmonth'].'-'.$param['bday'])).'\'');
				}
			if($param['gender']>0)
				array_push($arr_temp, 'GenderId = '.$param['gender']);
			if(trim(urldecode($param['opadd']))!='' && $param['opadd']=='1'){
				if(trim(urldecode($param['ayear']))!='' && intval($param['ayear'])>0 && checkdate(intval($param['amonth']), intval($param['aday']), intval($param['ayear'])))
					array_push($arr_temp, 'DATE_FORMAT(AddedDate,\'%Y-%m-%d\') >= \''.date('Y-m-d', strtotime($param['ayear'].'-'.$param['amonth'].'-'.$param['aday'])).'\'');
				}
			if(trim(urldecode($param['opadd']))!='' && $param['opadd']=='2'){
				if(trim(urldecode($param['ayear']))!='' && intval($param['ayear'])>0 && checkdate(intval($param['amonth']), intval($param['aday']), intval($param['ayear'])))
					array_push($arr_temp, 'DATE_FORMAT(AddedDate,\'%Y-%m-%d\') <= \''.date('Y-m-d', strtotime($param['ayear'].'-'.$param['amonth'].'-'.$param['aday'])).'\'');
				}
			if(trim(urldecode($param['opst']))!='' && $param['opst']=='1'){
				if(trim(urldecode($param['syear']))!='' && intval($param['syear'])>0 && checkdate(intval($param['smonth']), intval($param['sday']), intval($param['syear'])))
					array_push($arr_temp, 'DATE_FORMAT(StartDate,\'%Y-%m-%d\') >= \''.date('Y-m-d', strtotime($param['syear'].'-'.$param['smonth'].'-'.$param['sday'])).'\'');
				}
			if(trim(urldecode($param['opst']))!='' && $param['opst']=='2'){
				if(trim(urldecode($param['syear']))!='' && intval($param['syear'])>0 && checkdate(intval($param['smonth']), intval($param['sday']), intval($param['syear'])))
					array_push($arr_temp, 'DATE_FORMAT(StartDate,\'%Y-%m-%d\') <= \''.date('Y-m-d', strtotime($param['syear'].'-'.$param['smonth'].'-'.$param['sday'])).'\'');
				}
			if(trim(urldecode($param['opend']))!='' && $param['opend']=='1'){
				if(trim(urldecode($param['eyear']))!='' && intval($param['eyear'])>0 && checkdate(intval($param['emonth']), intval($param['eday']), intval($param['eyear'])))
					array_push($arr_temp, 'DATE_FORMAT(EndDate,\'%Y-%m-%d\') >= \''.date('Y-m-d', strtotime($param['eyear'].'-'.$param['emonth'].'-'.$param['eday'])).'\'');
				}
			if(trim(urldecode($param['opend']))!='' && $param['opend']=='2'){
				if(trim(urldecode($param['eyear']))!='' && intval($param['eyear'])>0 && checkdate(intval($param['emonth']), intval($param['eday']), intval($param['eyear'])))
					array_push($arr_temp, 'DATE_FORMAT(EndDate,\'%Y-%m-%d\') <= \''.date('Y-m-d', strtotime($param['eyear'].'-'.$param['emonth'].'-'.$param['eday'])).'\'');
				}
			if($param['supvisor']>0)
				array_push($arr_temp, 'Supervisor = '.$param['supvisor']);
			if($param['emptype']>0)
				array_push($arr_temp, 'EmployeeType = '.$param['emptype']);
			if($param['group']>0)
				array_push($arr_temp, 'GroupId = '.$param['group']);
			}
		$this->view->mlist = $this->user->GeneratEmailList($arr_temp);
		parent::loadModel('gender');
		$this->view->genders = $this->gender->getObjGender();
		parent::loadModel('emptype');
		$this->view->types = $this->emptype->getObjType();
		$this->user->setGroupId(2);
		$this->view->visor = $this->user->getAllSupervisors();
		parent::loadModel('group');
		$this->view->groups = $this->group->getObjGroup();
		$this->view->render('admin/generatemailing');
    	}
	public function sitesetingAction(){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsetting'])){
			if(!isset($_POST['sitename']) || trim($_POST['sitename'])=='')
				$this->view->err_n = 'Please enter site name';
			elseif(!isset($_POST['copyright']) || trim($_POST['copyright'])=='')
				$this->view->err_c = 'Please enter the copyright text';
			elseif(!isset($_POST['perday']) || intval($_POST['perday'])==0)
				$this->view->err_pd = 'Please enter num of work hour per day';
			elseif(!isset($_POST['firstpage']) || trim($_POST['firstpage'])=='')
				$this->view->err_f = 'Please enter label first page';
			elseif(!isset($_POST['lastpage']) || trim($_POST['lastpage'])=='')
				$this->view->err_l = 'Please enter label last page';
			elseif(!isset($_POST['showeach']) || trim($_POST['showeach'])=='' || intval($_POST['showeach'])==0)
				$this->view->err_s = 'Please enter page show each side';
			elseif(!isset($_POST['perpage']) || trim($_POST['perpage'])=='' || intval($_POST['perpage'])==0)
				$this->view->err_p = 'Please enter records per page';
			elseif(!isset($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter the copyright text';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Email address invalid';
			else{
				$_err = 0;
				$filename = NULL;
				if(!empty($_FILES['logo']['name'])){
					$extension = pathinfo($_FILES['logo']['name']);
					$extension = $extension['extension'];
					list($width, $height, $type, $w) = getimagesize($_FILES['logo']['tmp_name']);
					if($_FILES['logo']['size']/1024 > 50000){
						$this->view->err_g = 'Max file size is 5MB';
						$_err = 1;
						}
					elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
						$this->view->err_g = 'File format is \'gif, jpg, jpeg, png\'';
						$_err = 1;
						}
					elseif($width>484 || $height>75){
						$this->view->err_g = 'Recommended max-width:484px and max-height:75px';
						$_err = 1;
						}
					else{
						$temp = $this->random_string(16);
						$filename = $temp.'.'.$extension;
						if(!move_uploaded_file($_FILES['logo']['tmp_name'],dirname(dirname(__FILE__)).'/public/fuploads/'.$filename)){
							$this->view->err_g = 'An error while upload file';
							$_err = 1;
							}				
						}
					}
				if($_err==0){
					parent::loadModel('backup');
					$data = array(addslashes(trim($_POST['sitename'])), $_POST['perday'], addslashes(htmlentities(trim($_POST['copyright']))), $filename, addslashes(trim($_POST['firstpage'])), addslashes(trim($_POST['lastpage'])), intval($_POST['showeach']), intval($_POST['perpage']), addslashes(trim($_POST['email'])), $_POST['dfcalendar']);
					if(!$this->backup->updSettingSite($data))
						$this->view->error = 'An error occurred, please try again';
					else $this->view->succ = 'Your settings saved successfull';
					}
				}
			}
		parent::loadModel('calendar');
		$this->view->calen = $this->calendar->getCalendars();
		$this->view->render('admin/siteseting');
    	}
	public function approvalbookingAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		$this->user->setSupervisor($_SESSION['adid']);
		parent::loadModel('booktimeoff');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smapp'])){
			$app_id = array();
			$rej_id = array();
			for($i=1; $i<$_POST['hddtotal']; ++$i){
				if($_POST['app'.$i]==2)
					array_push($app_id, $_POST['hddid'.$i]);
				elseif($_POST['app'.$i]==4)
					array_push($rej_id, $_POST['hddid'.$i]);
				}
			parent::loadModel('notifications');
			parent::loadModel('schedule');
			parent::loadModel('status');
			if(count($app_id)>0){
				$this->status->setId(2);
				$status = $this->status->getObjStatus();
				$this->booktimeoff->setStatus(2);
				if($this->booktimeoff->ProcessBook(implode(',', $app_id), $_SESSION['adid'], $status->getDescription())>0){
					$arr = $this->booktimeoff->getInfoToMail(implode(',', $app_id));
					$this->notifications->setId(1);
					$notify = $this->notifications->getObjNotify();
					foreach($arr as $varr){
						if($varr->BookingApproved==1){
							$this->booktimeoff->setId($varr->Id);
							$this->booktimeoff->setUserId($varr->UserId);
							$dt = $this->booktimeoff->getBookToView();
							$this->schedule->setId($dt->ScheduleId);
							$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
							$row = (object)array('StartDate'=>$dt->StartDate, 'EndDate'=>$dt->EndDate,'StartType'=>$dt->StartType,'EndType'=>$dt->EndType,'StartHours'=>$dt->StartHours,'EndHours'=>$dt->EndHours);
							$arr_frm = array('$TIMEOFFTYPE','$TIMEOFFSTART','$TIMEOFFEND','$TIMEOFFCOMMENT','$COMMENT','$TIMEOFFDAYSREQUESTED','$URL');
							$arr_to = array($dt->TimeOffName,$dt->StartDate,$dt->EndDate,$dt->AdditionDetails,$status->getDescription(),$this->booktimeoff->__caculationDays($row),BASE_URL.'?member');
							$newmess = str_replace($arr_frm, $arr_to, html_entity_decode($notify->getBodyMail()));
							@mail(trim($varr->Email), '=?UTF-8?B?'.base64_encode($notify->getSubject().' - '.$this->settings->SiteName).'?=', $newmess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
							}
						}
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			if(count($rej_id)>0){
				$this->status->setId(4);
				$status = $this->status->getObjStatus();
				$this->booktimeoff->setStatus(4);
				if($this->booktimeoff->ProcessBook(implode(',', $rej_id), $_SESSION['adid'], $status->getDescription())>0){
					$arr = $this->booktimeoff->getInfoToMail(implode(',', $rej_id));
					$this->notifications->setId(4);
					$notify = $this->notifications->getObjNotify();
					foreach($arr as $varr){
						if($varr->BookingRejected==1){
							$this->booktimeoff->setId($varr->Id);
							$this->booktimeoff->setUserId($varr->UserId);
							$dt = $this->booktimeoff->getBookToView();
							$this->schedule->setId($dt->ScheduleId);
							$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
							$row = (object)array('StartDate'=>$dt->StartDate, 'EndDate'=>$dt->EndDate,'StartType'=>$dt->StartType,'EndType'=>$dt->EndType,'StartHours'=>$dt->StartHours,'EndHours'=>$dt->EndHours);
							$arr_frm = array('$TIMEOFFTYPE','$TIMEOFFSTART','$TIMEOFFEND','$TIMEOFFCOMMENT','$COMMENT','$TIMEOFFDAYSREQUESTED','$URL');
							$arr_to = array($dt->TimeOffName,$dt->StartDate,$dt->EndDate,$dt->AdditionDetails,$status->getDescription(),$this->booktimeoff->__caculationDays($row),BASE_URL.'?member');
							$newmess = str_replace($arr_frm, $arr_to, html_entity_decode($notify->getBodyMail()));
							@mail(trim($varr->Email), '=?UTF-8?B?'.base64_encode($notify->getSubject().' - '.$this->settings->SiteName).'?=', $newmess, 'Content-Type: text/html; charset=utf-8\r\nFrom: '.$this->settings->AdminEmail);
							}
						}
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			$this->user->setId($_SESSION['adid']);
			}
		$config['lastpage'] = $this->settings->LastPage;
		$config['firstpage'] = $this->settings->FirstPage;
		$config['showeachside'] = $this->settings->ShowEachSide;
		$config['per_page'] = $this->settings->RecordsPerPage;
		$config['js_numrows_page'] = count($this->booktimeoff->AdminGetBooksApp($this->user->getUsersManageByMe(), ''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managebooking'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = ' limit '.$config['rs_start'].', '.$config['per_page'];
		$this->view->books = $this->booktimeoff->AdminGetBooksApp($this->user->getUsersManageByMe(), $limit);
		$this->view->total = $config['js_numrows_page'];
		$this->view->render('admin/approvalbooking');
    	}
	public function viewuserAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		$this->view->id = $param['id'];
		$this->user->setGroupId(2);
		$this->view->visor = $this->user->getAllSupervisors();
		$this->user->setId($param['id']);
		$newuser = $this->user->getUser();
		$this->view->user = $this->user->ViewUser();
		parent::loadModel('timeofftype');
		$timeoff = $this->timeofftype->getTimeoffType();
		$this->view->types = $timeoff;
		$info = array();
		parent::loadModel('schedule');
		$this->schedule->setId($newuser->getCalendarId());
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
		$this->booktimeoff->setUserId($param['id']);
		foreach($timeoff as $vtimeoff){
			$this->booktimeoff->setType($vtimeoff->getId());
			$info[$vtimeoff->getId()] = $this->booktimeoff->getBookTimeOffForMember(date('Y'), '');
			}
		$this->view->info = $info;
		$this->view->minyear = $this->booktimeoff->getYear('min');
		$this->view->maxyear = $this->booktimeoff->getYear('max');
		$this->view->render('admin/viewuser');
		}
	public function loadingdataAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if(!array_key_exists('uid',$param) && intval($param['uid'])==0)
			die('Your bad URL');
		$this->view->id = $param['uid'];
		$this->user->setId($param['uid']);
		$newuser = $this->user->getUser();
		parent::loadModel('schedule');
		$this->schedule->setId($newuser->getCalendarId());
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
		$this->booktimeoff->setUserId($param['uid']);
		$this->booktimeoff->setType($param['vid']);
		$this->view->listoff = $this->booktimeoff->getBookTimeOffForMember($param['y'], '');
		$this->view->render('admin/loadingdata');
		}
	public function loaddefaultAction(array $param){
		if(!isset($_SESSION['adid'])){
			header('Location: '.BASE_URL.'?admincp&login');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		$this->view->id = $param['id'];
		$this->user->setId($param['id']);
		$newuser = $this->user->getUser();
		parent::loadModel('timeofftype');
		$timeoff = $this->timeofftype->getTimeoffType();
		$this->view->types = $timeoff;
		$info = array();
		parent::loadModel('schedule');
		$this->schedule->setId($newuser->getCalendarId());
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
		$this->booktimeoff->setUserId($param['id']);
		foreach($timeoff as $vtimeoff){
			$this->booktimeoff->setType($vtimeoff->getId());
			$info[$vtimeoff->getId()] = $this->booktimeoff->getBookTimeOffForMember($param['y'], '');
			}
		$this->view->info = $info;
		$this->view->render('admin/loaddefault');
		}
	}