<?php
defined('APP') or die('Hacking attemp!');
class Controller_Index extends Core_Controller{
	private $UserLogin;
	private $HolidaysInWeek;
	function __construct(){
		parent::__construct();
		parent::loadModel('schedule');
		$userSchedule = array();
		if(isset($_SESSION['uid'])){
			parent::loadModel('user');
			$this->user->setId($_SESSION['uid']);
			$this->UserLogin = $this->user->getUser();
			$this->settings->CalendarId = $this->UserLogin->getCalendarId();
			$this->view->user = $this->UserLogin;
			$this->schedule->setId($this->UserLogin->getScheduleId());
			$userSchedule = $this->schedule->getHolidaysInWeek();
			}
		$this->view->userSchedule = $userSchedule;
		$this->HolidaysInWeek = $this->schedule->getAllInWeek();
		$this->view->HolidaysInWeek = $this->HolidaysInWeek;
		$this->view->settings = $this->settings;
		}
    public function indexAction(){
		$this->view->title = $this->settings->SiteName;
		$currentdate = date('Y-m-d');
		$this->view->currdate = $currentdate;
		$temp = date('N', strtotime (date('Y-m-', strtotime($currentdate)).'1'));
		$newdate = strtotime ( '- '.$temp.' days' , strtotime (date('Y-m-', strtotime($currentdate)).'1') ) ;
		$startday = date('Y-m-d', $newdate);
		$this->view->startday = $startday;
		$this->view->enddate = date('Y-m-', strtotime($currentdate)).cal_days_in_month(CAL_GREGORIAN, date('m', strtotime($currentdate)), date('Y', strtotime($currentdate)));
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->HolidayInWeek = $this->HolidaysInWeek;
		$this->booktimeoff->setStartDate($startday);
		$this->booktimeoff->setEndDate(date('Y-m-', strtotime($currentdate)).cal_days_in_month(CAL_GREGORIAN, date('m', strtotime($currentdate)), date('Y', strtotime($currentdate))));
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->setCalendarId($this->settings->CalendarId);
		$this->view->listtrack = $this->booktimeoff->getListTracking($this->HolidaysInWeek);
		parent::loadModel('holiday');
		$this->holiday->setHolidayCalendar($this->settings->CalendarId);
		$this->view->holidays = $this->holiday->getArrayHolidays('');
        $this->view->render('home');
    	}
	public function loginAction(){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsignin'])){
			if(!isset($_POST['username']) || trim($_POST['username'])=='')
				$this->view->err_e = 'Please enter email address';
			elseif(!$this->valid_email(trim($_POST['username'])))
				$this->view->err_e = 'Email address is valid';
			elseif(!isset($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter email address';
			else{
				parent::loadModel('user');
				$this->user->setEmail(trim($_POST['username']));
				$this->user->setPassword(trim($_POST['password']));
				$rs = $this->user->UserLogin();
				if($rs>0){
					$_SESSION['uid'] = $rs;
					header('Location: '.BASE_URL);
					return;
					}
				elseif($rs==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($rs==-2 || $rs==-3)
					$this->view->error = 'Email or password incorect';
				}
			}
		$this->view->title = $this->settings->SiteName.' - Login system';
		$this->view->settings = $this->settings;
		$this->view->render('signin');
		}
	public function logoutAction(){
		unset($_SESSION['uid']);
		header('Location: '.BASE_URL);
		return;
		}
	public function changemonthAction(array $param){
		if(isset($param['t']) && trim($param['t'])=='minus'){
			$var = date('Y-m', strtotime ($param['m']));
			$next = strtotime ( '- 1 months' , strtotime ($var.'-1') );
			}
		elseif(isset($param['t']) && trim($param['t'])=='plus'){
			$var = date('Y-m', strtotime ($param['m']));
			$next = strtotime ( '+ 1 months' , strtotime ($var.'-1') );
			}
		else{
			$var = date('Y-m');
			$next = strtotime($var.'-1');
			}
		$temp = date('N', $next);
		$newdate = strtotime ( '- '.$temp.' days' , strtotime (date('Y-m', $next).'-1') ) ;
		$startday = date('Y-m-d', $newdate);
		$this->view->startday = $startday;
		$this->view->enddate = date('Y-m-', $next).cal_days_in_month(CAL_GREGORIAN, date('m', $next), date('Y', $next));
		$this->view->next = $next;
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->setCalendarId($this->settings->CalendarId);
		$this->booktimeoff->setStartDate($startday);
		$this->booktimeoff->setEndDate(date('Y-m-', $next).cal_days_in_month(CAL_GREGORIAN, date('m', $next), date('Y', $next)));
		$this->view->listtrack = $this->booktimeoff->getListTracking($this->HolidaysInWeek);
		parent::loadModel('holiday');
		$this->holiday->setHolidayCalendar($this->settings->CalendarId);
		$this->view->holidays = $this->holiday->getArrayHolidays();
		$this->view->render('calendar/calemonth');
		}
	public function changeweekAction(array $param){
		$totime = (isset($param['m']) && !empty($param['m']))?strtotime($param['m']):strtotime(date('Y-m-d'));
		if(isset($param['t']) && trim($param['t'])=='minus')
			$newdate = strtotime ( '- 1 weeks' , $totime);
		elseif(isset($param['t']) && trim($param['t'])=='plus')
			$newdate = strtotime ( '+ 1 weeks' , $totime);
		else{
			$temp = date('N', $totime);
			if(date('N', $totime)<7)
				$newdate = strtotime ( '- '.$temp.' days' , strtotime (date('Y-m-d', $totime)) ) ;
			else $newdate = $totime;
			if(array_key_exists('at', $param) && strtolower($param['at'])=='bookweek'){
				$temp = date('N', $newdate);
				$newdate = strtotime ( '- '.$temp.' days' , $newdate) ;
				$newdate = strtotime ( '+ 1 weeks' , $newdate);
				}
			elseif(strtotime(date('Y-m', $newdate)) != strtotime(date('Y-m'))){
				$newtime = strtotime(date('Y-m-', $totime).'1');
				$temp = date('N', $newtime);
				if(date('N', $newtime)<7)
					$newdate = strtotime ( '- '.$temp.' days' , strtotime (date('Y-m-d', $newtime)) ) ;
				else $newdate = $newtime;
				}
			}
		$this->view->newdate = $newdate;
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->setStartDate(date('Y-m-d', $newdate));
		$end = strtotime ( '+ 1 weeks' , $newdate);
		$this->booktimeoff->setEndDate(date('Y-m-d', $end));
		$this->booktimeoff->setCalendarId($this->settings->CalendarId);
		$this->view->listtrack = $this->booktimeoff->getListTracking($this->HolidaysInWeek);
		$this->view->startday = date('Y-m-d', $newdate);
		$this->view->enddate = date('Y-m-d', $end);
		parent::loadModel('holiday');
		$this->holiday->setHolidayCalendar($this->settings->CalendarId);
		$this->view->holidays = $this->holiday->getArrayHolidays();
		$this->view->render('calendar/changeweek');
		}
	public function reloadmonthAction(array $param){
		$currentdate = date('Y-m-d');
		$this->view->currdate = $currentdate;
		$temp = date('N', strtotime (date('Y-m-', strtotime($currentdate)).'1'));
		$newdate = strtotime ( '- '.$temp.' days' , strtotime (date('Y-m-', strtotime($currentdate)).'1') ) ;
		$startday = date('Y-m-d', $newdate);
		$this->view->startday = $startday;
		$this->view->enddate = date('Y-m-', strtotime($currentdate)).cal_days_in_month(CAL_GREGORIAN, date('m', strtotime($currentdate)), date('Y', strtotime($currentdate)));
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->setCalendarId($this->settings->CalendarId);
		$this->booktimeoff->setStartDate($startday);
		$this->booktimeoff->setEndDate(date('Y-m-', strtotime($currentdate)).cal_days_in_month(CAL_GREGORIAN, date('m', strtotime($currentdate)), date('Y', strtotime($currentdate))));
		$this->view->listtrack = $this->booktimeoff->getListTracking($this->HolidaysInWeek);
		parent::loadModel('holiday');
		$this->holiday->setHolidayCalendar($this->settings->CalendarId);
		$this->view->holidays = $this->holiday->getArrayHolidays();
		$this->view->render('calendar/reloadmonth');
		}
	public function lbmonthAction(array $param){
		$this->view->curdate = $param['m'];
		$this->view->ltype = $param['t'];
		$this->view->option = $param['o'];
		$this->view->render('calendar/lbmonth');
		}
	public function topbuttonAction(array $param){
		$this->view->curdate = $param['m'];
		$this->view->ltype = $param['t'];
		$this->view->option = $param['o'];
		$this->view->render('calendar/topbutton');
		}
	public function bookdetailAction(array $param){
		if(!array_key_exists('id', $param)){
			echo 'Your bad URL !';
			return;
			}
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setId($param['id']);
		$this->booktimeoff->setUserId($param['u']);
		$this->view->timeof = $this->booktimeoff->getBookToView();
		parent::loadModel('history');
		$this->history->setBookTimeId($param['id']);
		$this->view->logs = $this->history->getListLog();
		$this->view->bookid = $param['id'];
		$this->view->viewtype = $param['vt'];
		$this->view->render('bookdetail');
		}
	public function loadinfovacatontypeAction(array $param){
		if(!array_key_exists('id', $param)){
			echo json_encode(array('validnow'=>0, 'requested'=>0, 'remained'=>0));
			return;
			}
		parent::loadModel('timeofftype');
		$this->timeofftype->setId($param['id']);
		$result = $this->timeofftype->getTimeoffType();
		parent::loadModel('booktimeoff');
		$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
		$this->booktimeoff->HolidayInWeek = $this->schedule->getHolidaysInWeek();
		$this->booktimeoff->setUserId($_SESSION['uid']);
		$this->booktimeoff->setType($param['id']);
		$this->booktimeoff->setCalendarId($this->settings->CalendarId);
		echo json_encode(array('validnow'=>$result->getAlowDays(), 'requested'=>$this->booktimeoff->getTotalBookTimeUserVationType(), 'remained'=>$result->getAlowDays()-$this->booktimeoff->getTotalBookTimeUserVationType()));
		}
	public function changedaytypeAction(array $param){
		if(!array_key_exists('id', $param)){
			echo json_encode(array('hours'=>0, 'starttime'=>0));
			return;
			}
		parent::loadModel('daytype');
		$this->daytype->setId($param['id']);
		$result = $this->daytype->getDayType();
		echo json_encode(array('hours'=>$result->getHours(), 'starttime'=>$result->getStartTime()));
		}
	public function reloaddataAction(array $param){
		if(trim(strtolower($param['at']))=='bookmonth'){
			$var = date('Y-m', strtotime ($param['m']));
			$var = strtotime ($var.'-1');
			$currentdate = date('Y-m-d', $var);
			$this->view->currdate = $currentdate;
			$temp = date('N', strtotime (date('Y-m-', strtotime($currentdate)).'1'));
			$newdate = strtotime ( '- '.$temp.' days' , strtotime (date('Y-m-', strtotime($currentdate)).'1') ) ;
			$startday = date('Y-m-d', $newdate);
			$this->view->startday = $startday;
			$this->view->enddate = date('Y-m-', strtotime($currentdate)).cal_days_in_month(CAL_GREGORIAN, date('m', strtotime($currentdate)), date('Y', strtotime($currentdate)));
			parent::loadModel('booktimeoff');
			$this->booktimeoff->setHourPerDay($this->settings->HoursPerDay);
			$this->booktimeoff->setCalendarId($this->settings->CalendarId);
			$this->booktimeoff->setStartDate($startday);
			$this->booktimeoff->setEndDate(date('Y-m-', strtotime($currentdate)).cal_days_in_month(CAL_GREGORIAN, date('m', strtotime($currentdate)), date('Y', strtotime($currentdate))));
			$this->view->listtrack = $this->booktimeoff->getListTracking($this->HolidaysInWeek);
			$this->view->next = (strtotime(date('Y-m', strtotime ($param['m'])))==strtotime(date('Y-m')))?strtotime(date('Y-m-d')):$var;
			parent::loadModel('holiday');
			$this->holiday->setHolidayCalendar($this->settings->CalendarId);
			$this->view->holidays = $this->holiday->getArrayHolidays();
			$this->view->render('loadafter_addbook');
			}
		elseif(trim(strtolower($param['at']))=='bookweek'){
			$this->changeweekAction($param);
			}
		}
	public function companyholidayAction(){
		parent::loadModel('calendar');
		$this->view->calendars = $this->calendar->getCalendars();
		parent::loadModel('holiday');
		$this->holiday->setHolidayCalendar($this->settings->CalendarId);
		$this->view->holidays = $this->holiday->getHolidaysFromCalendar('');
		$this->view->minyear = $this->holiday->getYear('min');
		$this->view->maxyear = $this->holiday->getYear('max');
		$this->view->title = $this->settings->SiteName.' - Company holidays';
		$this->view->settings = $this->settings;
		$this->view->render('company');
		}
	public function changeholidayAction(array $param){
		if(!array_key_exists('id', $param) || !array_key_exists('y', $param)){
			echo 'Your bad URL';
			return;
			}
		parent::loadModel('holiday');
		$this->holiday->setHolidayCalendar($param['id']);
		$this->view->holidays = $this->holiday->getHolidaysFromCalendar($param['y']);
		$this->view->render('changeholiday');
		}
	public function morebooksAction(array $param){
		if(!array_key_exists('da', $param)){
			echo 'Your bad URL';
			return;
			}
		parent::loadModel('booktimeoff');
		$this->view->more = $this->booktimeoff->getMoreBooksDate($param['da']);
		$this->view->render('morebooks');
		}
	public function pagesAction(array $param){
		parent::loadModel('page');
		$this->page->setId($param['id']);
		$content = $this->page->getPage();
		$this->view->content = $content;
		$this->view->title = $this->settings->SiteName.' - '.$content->getPageName();
		$this->view->settings = $this->settings;
		$this->view->render('page');
		}
	public function forgotAction(array $param){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smforgot'])){
			if(!isset($_POST['username']) || trim($_POST['username'])=='')
				$this->view->err_u = 'Please enter email address';
			elseif(!$this->valid_email(trim($_POST['username'])))
				$this->view->err_u = 'Your email invalid';
			elseif(!isset($_POST['security']) || trim($_POST['security'])=='')
				$this->view->err_s = 'Please enter security code';
			elseif(trim($_POST['security'])!=$_SESSION['encoded_captcha'])
				$this->view->err_s = 'Security code is not math';
			else{
				parent::loadModel('user');
				$this->user->setEmail(addslashes($_POST['username']));
				$rs = $this->user->ForgotPassword($this->random_string(32));
				if(!is_numeric($rs)){
					$mess = 'Dear, '.$_POST['username'].'<br><br>Click on the following link to reset your password:<br> '.BASE_URL.'?index&recovery&key='.$rs;
					if(!mail(trim($_POST['username']), '=?UTF-8?B?'.base64_encode($this->settings->SiteName.' - Forgot password').'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".trim($this->settings->AdminEmail)))
						$this->view->error = 'Can not send to your email !';
					else $this->view->succ = 'Please check your email to reset your password.';
					}
				elseif($rs==-1 || $rs==-4)
					$this->view->error = 'An error occurred, please try again';
				elseif($rs==-2)
					$this->view->error = 'This email is not already in use';
				elseif($rs==-3)
					$this->view->error = 'Your account is not active';
				}
			}
		$this->view->title = $this->settings->SiteName.' - Forgot password';
		$this->view->settings = $this->settings;
		$this->view->render('forgot');
		}
	public function recoveryAction(array $param){
		if(!array_key_exists('key', $param))
			$this->view->invalid = 'Your bad URL !';
		parent::loadModel('user');
		if(!$this->user->chkKey(addslashes($param['key'])))
			$this->view->invalid = 'Your bad URL !';
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsavepass'])){
			if(!isset($_POST['newpass']) || trim($_POST['newpass'])=='')
				$this->view->err_n = 'Please enter new password';
			elseif(trim($_POST['newpass'])!=trim($_POST['renewpass']))
				$this->view->err_r = 'Password is not math';
			else{
				$this->user->setPassword(addslashes($_POST['newpass']));
				$this->user->setStrActive(addslashes($param['key']));
				if($this->user->ResetPassword($this->random_string(8))>0)
					$this->view->succ = 'Your password reseted successfull';
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->title = $this->settings->SiteName.' - Recovery password';
		$this->view->settings = $this->settings;
		$this->view->render('recovery');
		}
	}